

local major, minor, libTable = LibStub("LibBuilder-1.0"):GetLib()
if not libTable.canLoad then return end


local Core = libTable.classes:NewClass("Core", true)


---	Internal; Checks if the client has assigned names to the tabs yet.
--	@return tabsAvailable	True if tab names are available, false otherwise.
function Core:AreTabsAvailable()
	return GetChatWindowInfo(1) ~= ""
end


--	Internal; used to dump the cache if tab names weren't available.
function Core:UPDATE_CHAT_WINDOWS()
	if #Core.messageCache > 0 then
		for i, data in ipairs(Core.messageCache) do
			data.stream:Print(data.message)
		end
	end
end


function Core:Hook()
	local frame = CreateFrame("Frame")
	frame:SetScript("OnEvent", function(...) self:UPDATE_CHAT_WINDOWS(...) end)
	frame:RegisterEvent("UPDATE_CHAT_WINDOWS")
end


function Core:QueueMessage(message, stream)
	if table.maxn(self.messageCache) == 0 then
		print(string.format("%s: caching messages", major))
	end
	table.insert(self.messageCache, { message = message, stream = stream })
end
